
public class CreateThread {

	public static void main(String[] args) {
		
		// Anonyme Klasse erbt von Thread
		new Thread() {
			public void run() { // berschreibt die Methode run in Thread
				System.out.println("Anonyme Klasse erbt von Thread");
				// do something
			}
		}.start();
		
		
		// Anonyme Klasse implementiert Runnable und wird einem Thread als
		// Argument bergeben.
		new Thread(new Runnable() {
			public void run() { // berschreibt die Methode run in Runnable
				System.out.println("Anonyme Klasse erbt von Thread mit Runnable als Argument");
				// do something
			}
		}).start();
		
		
		// Neue Instanz eines Threads
		Thread thread = new ExtendsThread();
		thread.start();
		// thread.start(); // funktioniert nicht, ein Thread kann nur einmal gestartet werden!
		
		
		// Starte Instanz eines Runnables immer wieder
		Runnable runnable = new ExtendsRunnable();
		new Thread(runnable).start();
		new Thread(runnable).start();
		new Thread(runnable).start();
		//...

	}
}

class ExtendsThread extends Thread {
	
	public void run() {
		System.out.println("Ich erbe von Thread");
		// do something
	}
}

class ExtendsRunnable implements Runnable {
	
	private int count = 0;
	
	public void run() {
		System.out.println("Ich implementiere Runnable");
		for (int i=0;i<1000000;i++) {
			
			/*
			 * Synchronized um jeweils nur einem Thread den Zugriff auf count zu
			 * erlauben.
			 */
			synchronized (this) {
				count++;
			}
		}
		System.out.println(count);
	}
}
